'This program implements the Jordan decomposition and prodvide the sorted matrices, L and Q
' such that L=Q^-1*A*Q, where Q's columns are eigenvectors and the L's diagonal elements are the eigenvalues of A. 



!n = @columns(A)

'Hessenberg Reduction (See Golub and Van Loan)
if !n>2 then
   matrix (!n) U0
   matrix (!n) Hp=@identity(!n)
   matrix (!n) R

   matrix RP=A
   for !i=1 to !n-2
       !k=!n-!i
       vector (!k) x
       for !j=1 to !k
           x(!j)=Rp(!j+!i,!i)
       next

      vector (!k) e=0

      e.fill(o=1,1) 1

      vector (!k) hv=x-@norm(x,2)*e

      matrix I=@identity(!k)

      !deno=@transpose(hv)*hv

     matrix HM=I-2*hv*@transpose(hv)/!deno

     matrix H=@identity(!n)

     for !l=2 to !k+1
          for !m= 2 to !k+1
              H(!l+!i-1,!m+!i-1)=HM(!l-1,!m-1)
          next
     next
   
  
     matrix U0=Hp*H
     matrix R=H*Hp*A
     matrix Hp=H
   
     matrix Rp=R

  next

  matrix H0=@transpose(U0)*A*U0
else

endif

'Schur decomposition

if !n < 3 then
   matrix U0=@identity(!n)
   matrix H0=A
else
  exec C:\Users\ktame\Desktop\hr.prg
endif

matrix PP=U0
matrix AA=H0
for !i=1 to 1000

    exec C:\Users\ktame\Desktop\QR.prg
    matrix QQ=Q
    matrix RR=R
    matrix AA=RR*QQ
    matrix PP=PP*QQ

next

  
vector eigen = @getmaindiagonal(AA)




matrix  l=AA
matrix Q=PP 

for !j=2 to !n
    for !i=1 to !j-1
     if @abs(AA(!i,!i))=@abs(AA(!i+1,!i+1)) then   
          string comm_eigen = "Your model has multiple roots (see 'eigen'). Please modify your model." 
          show comm_eigen
          stop
     else
     endif
        scalar z=-AA(!i,!j)/(AA(!i,!i)-AA(!j,!j))
        l(!i,!j)=0
        for !k=!j+1 to !n
            l(!i, !k)=AA(!i, !k)-z*AA(!j,!k)
        next
        for !k=1 to !n
            Q(!k, !j)=PP(!k,!i)*z+PP(!k,!j)
        next
   next
next

if @norm(A-Q*l*@inverse(Q),2)<0.001 then
   else
   string comm_jordan = "Your model has imaginary roots. Please modify your model" 
   show comm_jordan 
   stop
 endif


'Sort

matrix l_sort=l
matrix Q_sort=Q


for !j=1 to !n
     for !i=1 to !n-1
     if @abs(AA(!i,!i))=@abs(AA(!i+1,!i+1)) then   
          string comm_eigen = "Your model has multiple roots (see 'eigen'). Please modify your model." 
          show comm_eigen
          stop
     else
    endif
     if @abs(l_sort(!i,!i))<@abs(l_sort(!i+1,!i+1)) then
          
      
        else
        
        !d1=l_sort(!i,!i)
        !d2=l_sort(!i+1,!i+1)
        l_sort(!i+1,!i+1)=!d1 
          l_sort(!i,!i)=!d2
       matrix sort=@identity(!n)     
        sort(!i,!i)=0
        sort(!i+1,!i+1)=0
        sort(!i,!i+1)=1
        sort(!i+1,!i)=1
        Q_sort=Q_sort*sort
       endif
   next
next
